﻿using System;
using System.Runtime.InteropServices;
using JetBrains.Annotations;
using OpcLabs.BaseLib;

namespace OpcLabs.BaseLibFactory
{
    static public class NormalizedExceptionInstances
    {
        [NotNull]
        static public NormalizedException Instance1 => new NormalizedException(new Exception("message1"));

        [NotNull]
        static public NormalizedException Instance2 => new NormalizedException(new Exception("message2", new Exception("innerMessage2")));

        [NotNull]
        static public NormalizedException Instance3 => new NormalizedException(new Exception("message2", new Exception("innerMessage2", new Exception("innerMessage3"))));

        [NotNull]
        static public NormalizedException Instance4 => new NormalizedException(new COMException("message4"));

        [NotNull]
        static public NormalizedException Instance5 => new NormalizedException(new COMException("message5", new COMException("innerMessage6")));

        [NotNull]
        static public NormalizedException Instance6
        {
            get
            {
                NormalizedException normalizedException = Instance1;
                normalizedException.Data["key1"] = 1111;
                normalizedException.Data["key2"] = "string2222";
                return normalizedException;
            }
        }

        [NotNull]
        static public NormalizedException Instance7
        {
            get
            {
                NormalizedException normalizedException = Instance1;
                normalizedException.HelpLink = "testHelpLink";
                return normalizedException;
            }
        }

        [NotNull]
        static public NormalizedException Instance8
        {
            get
            {
                NormalizedException normalizedException = Instance1;
                normalizedException.Source = "testSource";
                return normalizedException;
            }
        }
    }
}
