﻿using JetBrains.Annotations;
using OpcLabs.BaseLib.ComInterop;
using OpcLabs.BaseLib.Xml;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.AddressSpace;

namespace OpcLabs.EasyOpcFactory.DataAccess.AddressSpace
{
    static public class DAPropertyElementInstances
    {
        [NotNull]
        static public DAPropertyElement Instance0 => new DAPropertyElement();

        [NotNull]
        static public DAPropertyElement Instance1 => new DAPropertyElement
        {
            PropertyId = DAPropertyIds.ChangeRateLimit,
            DataType = VarTypes.I4,
            ItemId = "TestItemId1",
            Description = "TestDescription1"
        };

        [NotNull]
        static public DAPropertyElement Instance2 => new DAPropertyElement
        {
            PropertyId = DAPropertyIds.Timestamp,
            DataType = VarTypes.UI4,
            ItemId = "TestItemId2",
            Description = "TestDescription2",
            ItemPath = "ItemPath2"
        };

        [NotNull]
        static public DAPropertyElement Instance3 => new DAPropertyElement
        {
            QualifiedName = new XmlQualifiedName2("testName", "testNs")
        };

        [NotNull]
        static public DAPropertyElement Instance4 => new DAPropertyElement
        {
            PropertyId = DAPropertyIds.Timestamp,
            QualifiedName = new XmlQualifiedName2("testName", "testNs")
        };
    }
}
