﻿
using JetBrains.Annotations;
using OpcLabs.BaseLib.Xml;
using OpcLabs.BaseLib.Xml.Collections;
using OpcLabs.EasyOpc.UA.DataTypeModel;

namespace OpcLabs.EasyOpcFactory.UA.DataTypeModel
{
    static public class UAOpcBinaryDtsParametersInstances
    {
        [NotNull]
        static public UAOpcBinaryDtsParameters Instance1 => new UAOpcBinaryDtsParameters(UADataTypeSystemParametersInstances.Instance1);

        [NotNull]
        static public UAOpcBinaryDtsParameters Instance2 => new UAOpcBinaryDtsParameters
        {
            AllowDataPastEndOfStream = false,
            OverrideLocationForKnownNamespaces = false
        };

        [NotNull]
        static public UAOpcBinaryDtsParameters Instance3 => new UAOpcBinaryDtsParameters
        {
            OverrideLocationForKnownNamespaces = false,
            TypeNameRemappingDictionary = new XmlQualifiedName2Dictionary()
        };

        [NotNull]
        static public UAOpcBinaryDtsParameters Instance4 => new UAOpcBinaryDtsParameters
        {
            TypeNameRemappingDictionary = new XmlQualifiedName2Dictionary
            {
                {
                    new XmlQualifiedName2("fromName1", "fromNamespace1"),
                    new XmlQualifiedName2("toName1", "toNamespace1")
                },
                {
                    new XmlQualifiedName2("fromName2", "fromNamespace2"),
                    new XmlQualifiedName2("toName2", "toNamespace2")
                }
            }
        };
    }
}
