﻿using System;
using System.Diagnostics;
using JetBrains.Annotations;
using OpcLabs.EasyOpc;

namespace OpcLabs.EasyOpcFactory
{
    static public class ServerElementInstances
    {
        [NotNull]
        static public ServerElement Instance1
        {
            get
            {
                var serverElement = new ServerElement();

                Debug.Assert(!serverElement.ServerCategories.OpcAlarmsAndEvents10);
                Debug.Assert(!serverElement.ServerCategories.OpcDataAccess10);
                Debug.Assert(!serverElement.ServerCategories.OpcDataAccess20);
                Debug.Assert(!serverElement.ServerCategories.OpcDataAccess30);
                Debug.Assert(!serverElement.ServerCategories.OpcXmlDataAccess10);
                return serverElement;
            }
        }

        [NotNull]
        static public ServerElement Instance2
        {
            get
            {
                var serverElement = new ServerElement
                {
                    Location = "TestLocation1",
                    Technology = OpcTechnologies.Com,
                    Clsid = Guid.NewGuid(),
                    ProgId = "TestProgId1",
                    Description = "TestDescription1",
                    Vendor = "TestVendor1",
                    VersionIndependentProgId = "TestVersionIndependentProgId1",
                    ServerCategories = { OpcAlarmsAndEvents10 = true, OpcDataAccess20 = true },
                    UrlString = "TestUriString1",
                };

                Debug.Assert(serverElement.ServerCategories.OpcAlarmsAndEvents10);
                Debug.Assert(!serverElement.ServerCategories.OpcDataAccess10);
                Debug.Assert(serverElement.ServerCategories.OpcDataAccess20);
                Debug.Assert(!serverElement.ServerCategories.OpcDataAccess30);
                Debug.Assert(!serverElement.ServerCategories.OpcXmlDataAccess10);
                return serverElement;
            }
        }

        [NotNull]
        static public ServerElement Instance3
        {
            get
            {
                var serverElement = new ServerElement
                {
                    Location = "TestLocation2",
                    Technology = OpcTechnologies.Xml,
                    Description = "TestDescription2",
                    Vendor = "TestVendor2",
                    ServerCategories = { OpcXmlDataAccess10 = true },
                    UrlString = "TestUriString2",
                };

                Debug.Assert(!serverElement.ServerCategories.OpcAlarmsAndEvents10);
                Debug.Assert(!serverElement.ServerCategories.OpcDataAccess10);
                Debug.Assert(!serverElement.ServerCategories.OpcDataAccess20);
                Debug.Assert(!serverElement.ServerCategories.OpcDataAccess30);
                Debug.Assert(serverElement.ServerCategories.OpcXmlDataAccess10);
                return serverElement;
            }
        }
    }
}
