﻿using Microsoft.Extensions.DependencyInjection;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Extensions;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.Implementation.NetApi.DataAccess;

namespace OpcLabs.EasyOpcLiveTest.DataAccess.Extensions
{
    /// <summary>
    ///This is a test class for EasyDAClientExtensionTest and is intended
    ///to contain all EasyDAClientExtensionTest Unit Tests
    ///</summary>
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class EasyDAClientExtensionTest_NoCom : EasyDAClientExtensionTestBase
    {
        protected override IEasyDAClient CreateClient()
        {
            var client = new EasyDAClient {InstanceParameters = {EnableNativeClient = false}};
            NetApiEasyDAClient netApiClient = client.GetService<NetApiEasyDAClient>();
            Assert.IsNotNull(netApiClient);
            netApiClient.Parameters_EnableComTechnology = false;
            return client;
        }
    }
}
