﻿using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.DataAccess;

namespace OpcLabs.EasyOpcLiveTest.DataAccess
{
    //[TestClass]
    // ReSharper disable once InconsistentNaming
    public class DAClientTest_Native
    {
        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class EasyDAClientCatalogTest_Native_IEasyDAClient_Functional : IEasyDAClientCatalogTest_Functional
        {
            public EasyDAClientCatalogTest_Native_IEasyDAClient_Functional()
                : base(
                    () => new EasyDAClient { InstanceParameters = { EnableNativeClient = true, EnableNetApiClient = false, EnableServiceClient = false } },
                    new DAServerCatalog(DAServerCatalogEntries.Real.Where(entry => 
                        // ReSharper disable PossibleNullReferenceException
                        entry.Element.Technology == OpcTechnologies.Com)))
                        // ReSharper restore PossibleNullReferenceException
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class EasyDAClientTest_Native_IEasyDAClient_BrowseNodes : IEasyDAClientTest_BrowseNodes
        {
            public EasyDAClientTest_Native_IEasyDAClient_BrowseNodes()
                : base(
                    () => new EasyDAClient { InstanceParameters = { EnableNativeClient = true, EnableNetApiClient = false, EnableServiceClient = false } })
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class EasyDAClientTest_Native_IEasyDAClient_BrowseServers : IEasyDAClientTest_BrowseServers
        {
            public EasyDAClientTest_Native_IEasyDAClient_BrowseServers()
                : base(() => new EasyDAClient { InstanceParameters = { EnableNativeClient = true, EnableNetApiClient = false, EnableServiceClient = false } })
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class EasyDAClientTest_Native_IEasyDAClient_Com : IEasyDAClientTest_Com
        {
            public EasyDAClientTest_Native_IEasyDAClient_Com()
                : base(() => new EasyDAClient { InstanceParameters = { EnableNativeClient = true, EnableNetApiClient = false, EnableServiceClient = false } })
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class EasyDAClientTest_Native_IEasyDAClient_Com_BrowseAccessPaths : IEasyDAClientTest_Com_BrowseAccessPaths
        {
            public EasyDAClientTest_Native_IEasyDAClient_Com_BrowseAccessPaths()
                : base(() => new EasyDAClient { InstanceParameters = { EnableNativeClient = true, EnableNetApiClient = false, EnableServiceClient = false } })
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class EasyDAClientTest_Native_IEasyDAClient_Com_BrowsePath : IEasyDAClientTest_Com_BrowsePath
        {
            public EasyDAClientTest_Native_IEasyDAClient_Com_BrowsePath()
                : base(() => new EasyDAClient { InstanceParameters = { EnableNativeClient = true, EnableNetApiClient = false, EnableServiceClient = false } })
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class EasyDAClientTest_Native_IEasyDAClient_Intrinsic : IEasyDAClientTest_Intrinsic
        {
            public EasyDAClientTest_Native_IEasyDAClient_Intrinsic()
                : base(() => new EasyDAClient { InstanceParameters = { EnableNativeClient = true, EnableNetApiClient = false, EnableServiceClient = false } })
            {
            }
        }
    }
}
