﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.AlarmsAndEvents;
using OpcLabs.EasyOpc.AlarmsAndEvents.Reactive;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy.AlarmsAndEvents.Reactive
{
    public class AEReactiveTest
    {
        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes

        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //

        #endregion

        [TestCategory("Live")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("TimeDomain")]
        [TestMethod]
        public void NotificationObservableTest()
        {
            const string machineName = "";
            const string serverClass = "OPCLabs.KitEventServer.2";

            var observable = AENotificationObservable.Create(machineName, serverClass, 100, 
                AESubscriptionFilter.Empty, AEAttributeSetDictionary.Empty);
            using (/*var subscription = */observable.Subscribe(e =>
                // ReSharper disable once PossibleNullReferenceException
                AssertUtilities.WriteLine((e.EventData == null) ? "" : e.EventData.Message)))
                AssertUtilities.WaitingPhase(10*1000);
        }
    }
}
