﻿using System;
using JetBrains.Annotations;
using OpcLabs.BaseLib.ComInterop;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.LiveMapping;
using OpcLabs.EasyOpcLiveTest.Legacy.Environment.OpcKitServer;

namespace OpcLabs.EasyOpcLiveTest.Legacy.LiveMapping._Testers
{
    class PropertyTester
    {
        private class SimulationNode2 : DAMappedNode
        {
            [DANode]
            // ReSharper disable InconsistentNaming
            public RegisterSetNode RegisterSet_1 { get; protected set; }
            // ReSharper restore InconsistentNaming

            [DANode(BrowsePath = "Incrementing"), DAProperty(DAPropertyIds.DataType)]
            public VarType VarType { get; set; }
        }

        private class RootNode2 : DAMappedNode
        {
            [DANode]
            [NotNull]
            public SimulationNode2 Simulation = new SimulationNode2();
        }

        public void Test()
        {
            var clientMapper = new DAClientMapper();
            var testTarget = new RootNode2();

            clientMapper.Map(testTarget, new DAMappingContext { ServerDescriptor = LegacyTestDefs.ProgIds.KitServer });

            clientMapper.Get();
            Console.WriteLine(testTarget.Simulation.VarType);
        }
    }
}
