﻿
using System;
using System.Globalization;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Net.Sockets;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.Discovery;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA
{
    public partial class EasyUAClientTest
    {
        #region Static Private Methods

        #endregion



        #region Test Methods
        // ReSharper disable InconsistentNaming

        [TestCategory("Live")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void FindLocalApplicationsTest_SingleDiscoveryUri()
        {
            var target = new EasyUAClient();
            const string discoveryHost = "localhost";   // TODO:
            if (!TcpClientUtilities.CanCreate(discoveryHost, 4840))
                Assert.Inconclusive("Failed pre-check: Socket exception.");
            UADiscoveryElementCollection discoveryElementCollection = target.FindLocalApplications(
                new[] { String.Format(CultureInfo.InvariantCulture, "opc.tcp://{0}:4840", discoveryHost) },
                UAApplicationTypes.Server);

            Assert.IsNotNull(discoveryElementCollection);
            Assert.IsTrue(discoveryElementCollection.Count >= 2, "Not enough application elements.");
            CollectionAssert.AllItemsAreNotNull(discoveryElementCollection);
            CollectionAssert.AllItemsAreUnique(discoveryElementCollection);

            // TODO: assert more
        }

        [TestCategory("Live")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void UAGlobalApplicationDiscoveryQueryTest()
        {
            UAEndpointDescriptor gdsEndpointDescriptor = "opc.tcp://" + LegacyTestDefs.MachineNames.OpcUaTest + ":58810/GlobalDiscoveryServer";
            TestEnvironment.PrecheckEndpoint(gdsEndpointDescriptor);

            var target = new EasyUAClient();
            var globalApplicationDiscoveryQuery = new UAGlobalApplicationDiscoveryQuery(gdsEndpointDescriptor);
            UADiscoveryElementCollection discoveryElementCollection = target.Discover(globalApplicationDiscoveryQuery);

            Assert.IsNotNull(discoveryElementCollection);
            Assert.IsTrue(discoveryElementCollection.Count >= 2, "Not enough application elements.");
            CollectionAssert.AllItemsAreNotNull(discoveryElementCollection);
            CollectionAssert.AllItemsAreUnique(discoveryElementCollection);

            // TODO: assert more
        }

        // ReSharper restore InconsistentNaming
        #endregion
    }
}
