﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA.OperationModel;
using OpcLabs.EasyOpcFactory.UA.OperationModel;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.OperationModel
{
    public partial class UAWriteValueArgumentsTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        static public UAWriteValueArguments CreateSerializationTarget0()
        {
            return new UAWriteValueArguments();
        }

        [NotNull]
        static public UAWriteValueArguments CreateSerializationTarget1()
        {
            return new UAWriteValueArguments(UAAttributeArgumentsInstances.Instance1)
            {
                Value = "value1",
                ValueType = typeof(string),
            };
        }
    }
}
