﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class FraunhoferGesselschaft_ProVisAgent_Test : UAInteroperabilityWorkshopTest
    {
        //public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[] { "" };

        //public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[] { "" };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=urn:FraunhoferIOSB:ProVisUARouter:Kern;ns=2;s=Pak1_OIL_LEVEL_mm_Ist",
            "nsu=urn:FraunhoferIOSB:ProVisUARouter:Kern;ns=2;s=Pak1_OIL_TEMP_GRA_Ist"
        };

        public override IEnumerable<int> DynamicSamplingIntervals => new[] { 5000, 10000 };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://iltwsdemo:52205" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new []
        {
            nameof(Group001_Session_Test02_CreateSession_UaTcp_Basic128Rsa15),
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group002_ViewServices_Test07_TranslateBrowsePathToNodeId_Components),
            nameof(Group003_AttributeServices_Test05_Read_Array_IndexRange),
            nameof(Group003_AttributeServices_Test07_Write_Array_IndexRange),
            nameof(Group005_InformationModel_Test04_Browse_Read_SessionDiagnosticsArray),
            nameof(Group008_Eventing_Test01_Subscribe_Server),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group009_DataChange_Test05_AbsoluteDeadbandFilter),
            nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
            nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override string Password => "Nbg.0815";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[]
        {
            "nsu=urn:FraunhoferIOSB:ProVisUARouter:Kern;ns=2;s=Pak2_BETRIEBSART_Ist",
            "nsu=urn:FraunhoferIOSB:ProVisUARouter:Kern;ns=2;s=Pak1_BETRIEBSART_Ist",
        };

        public override string UserName => "iop";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[] 
        {
            "nsu=urn:FraunhoferIOSB:ProVisUARouter:Kern;ns=2;s=HR_AnwahlPresse1_Frei",
            "nsu=urn:FraunhoferIOSB:ProVisUARouter:Kern;ns=2;s=HR_AnwahlPresse2_Frei",
        };
    }
}
