﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    // ReSharper disable once IdentifierTypo
    public class Honeywell_ExperionPksOpcUaDaHdaServer_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => 
            // ReSharper disable StringLiteralTypo
            new UANodeDescriptor[] { "ns=1;s=r511-esvt:temaana100.varfloatvector" };
        // ReSharper restore StringLiteralTypo

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            // ReSharper disable StringLiteralTypo
            "ns=1;s=r511-esvt:temaana100.pv",
            "ns=1;s=r511-esvt:temaana101.pv"
            // ReSharper restore StringLiteralTypo
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://10.10.100.65:4840" };

        public override string Password => "Opcua123";

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test02_CreateSession_UaTcp_Basic128Rsa15),
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group002_ViewServices_Test03_Browse_References),
            nameof(Group002_ViewServices_Test04_Browse_NodeClasses),
            nameof(Group003_AttributeServices_Test07_Write_Array_IndexRange),
            nameof(Group005_InformationModel_Test04_Browse_Read_SessionDiagnosticsArray),
            nameof(Group008_Eventing_Test01_Subscribe_Server),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group011_AlarmCondition_Test01_Browse_Types),
            nameof(Group013_Discovery_Test03_FindServers_LDS_ServerPresence),
            nameof(Group014_Challenge_Test02_ShortNetworkInterruption),
            nameof(Group014_Challenge_Test03_LongNetworkInterruption),

            nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
            nameof(Group102_Session2_Test02_CreateSession_UaTcp_Basic256Sha256),
            nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256),
            nameof(Group102_Session2_Test04_CreateSession_UaTcp_Aes128_Sha256_RsaOaep),
            nameof(Group102_Session2_Test05_CreateSession_UaTcp_Aes256_Sha256_RsaPss),
            nameof(Group114_Challenge2_Test01_LongRunningSubscription),
        });

        // ReSharper disable once StringLiteralTypo
        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "ns=1;s=04yf1.createtime" };

        public override string UserName => "TestUser";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => 
            // ReSharper disable StringLiteralTypo
            new UANodeDescriptor[] { "ns=1;s=r511-esvt:vic_db_ana001.tstreal" };
        // ReSharper restore StringLiteralTypo

        public override bool WriteWithUserNameIdentity => true;
    }
}
