﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class Iconics_Genesis64_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[] { "" };

        public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[] { "" };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "ns=1;s=modbus:DeviceReadOnlyDynamic.Single.Item_Float",
            "ns=1;s=modbus:DeviceReadOnlyDynamic.Single.Item_Double"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://ICO-DELL7720:5011" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group003_AttributeServices_Test05_Read_Array_IndexRange),
            nameof(Group003_AttributeServices_Test07_Write_Array_IndexRange),
            nameof(Group008_Eventing_Test01_Subscribe_Server),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group011_AlarmCondition_Test01_Browse_Types),
            //nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override string Password => "???";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "ns=1;s=modbus:DeviceReadWriteStatic.Single.Item_Int32" };

        public override string UserName => "???";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[] { "ns=1;s=modbus:DeviceReadWriteStatic.Single.Item_Int64" };
    }
}
