﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable IdentifierTypo
    public class KepwareTechnologies_KepwareEdge_Test : UAInteroperabilityWorkshopTest
        // ReSharper restore IdentifierTypo
    {
        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=KEPServerEX ;ns=2;s=Simulator.READONLY.32BIT.FLOAT0",
            "nsu=KEPServerEX ;ns=2;s=Simulator.READONLY.32BIT.DWORD1"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://192.168.1.27:49320" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test02_CreateSession_UaTcp_Basic128Rsa15),
            nameof(Group001_Session_Test03_ActivateSession_UserNameAndPassword),
            //nameof(Group001_Session_Test04_ActivateSession_UserIdentityAnonymous),
            nameof(Group001_Session_Test08_CreateSession_InstanceCertificate),
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group001_Session_Test11_CreateSession_UaTcp_Basic256Sha256),
            nameof(Group002_ViewServices_Test03_Browse_References),
            nameof(Group002_ViewServices_Test07_TranslateBrowsePathToNodeId_Components),
            nameof(Group003_AttributeServices_Test05_Read_Array_IndexRange),
            nameof(Group003_AttributeServices_Test07_Write_Array_IndexRange),
            nameof(Group005_InformationModel_Test03_Browse_ServerFolder),
            nameof(Group005_InformationModel_Test04_Browse_Read_SessionDiagnosticsArray),
            nameof(Group008_Eventing_Test01_Subscribe_Server),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group009_DataChange_Test05_AbsoluteDeadbandFilter),
            nameof(Group011_AlarmCondition_Test01_Browse_Types),
            nameof(Group013_Discovery_Test03_FindServers_LDS_ServerPresence),
            //nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
            //nameof(Group102_Session2_Test02_CreateSession_UaTcp_Basic256Sha256),
            //nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "nsu=KEPServerEX ;ns=2;s=Simulator.READWRITE.32BIT.DWORD1" };

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[] { "nsu=KEPServerEX ;ns=2;s=Simulator.READWRITE.32BIT.DWORD2" };
    }
}
